com.ihr.xbrl.mapper

## Interface MapperFileSaveInterface

- All Known Implementing Classes:
    Mapper

      public interface MapperFileSaveInterface

  Classes implementing this interface will be able to provide data for generating a mapper configuration file by calling the static save method on the Mapper class.
  Author:
    Ignacio

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Iterator<Fact>` | `getChildrenFacts()` Access to facts on the configuration file.
    `java.lang.String` | `getCompany()` Access to the generic string that corresponds with the company.
    `DTSContainer` | `getContainer()` Access to the DTSContainer in the scope of the surrounding XMLFragments.
    `MapperContext` | `getContextById(java.lang.String key)` Access to a specific context using the context key.
    `java.util.Collection<MapperContext>` | `getContexts()` Returns a collection of MapperContext objects that will be saved to this new file.
    `java.util.Iterator<java.lang.String>` | `getContextsKeys()` Returns an iterator over all context keys.
    `java.lang.String[]` | `getDtsURLs()` Access to all URLs that will be part of the DTS file section Note, all strings shall be valid converted to URIs to avoid errors.
    `java.lang.String` | `getScheme()` Access to the generic scheme string for the mapper configuration file Note, as this is a String, this may not be a valid URI.
    `java.util.Collection<Section>` | `getSections()` Access to the collection of sections.
    `XBRLDataSource` | `getSourceForKey(java.lang.String key)` Returns the XBRLDataSource for the key passed in as parameter.
    `java.util.Set<java.lang.String>` | `getSourceKeys()` Returns a collection of keys for XBRL data sources.
    `XBRLUnit` | `getUnitForKey(java.lang.String key)` Access to the unit associated with a specific key.
    `java.util.Set<java.lang.String>` | `getUnitKeys()` Access to the set of keys for units defined in this mapping configuration file.
    `java.net.URI` | `getUriOfConfigFile()` Access to the file name associated with the mapper configuration file.

- - ### Method Detail

    - #### getContexts

          java.util.Collection<MapperContext> getContexts()

      Returns a collection of MapperContext objects that will be saved to this new file.
      Returns:
        the contexts

    - #### getContextsKeys

          java.util.Iterator<java.lang.String> getContextsKeys()

      Returns an iterator over all context keys.
      Returns:
        the contexts keys

    - #### getContextById

          MapperContext getContextById(java.lang.String key)

      Access to a specific context using the context key.
      Parameters:
        `key` - the key
      Returns:
        MapperContext instance

    - #### getSourceKeys

          java.util.Set<java.lang.String> getSourceKeys()

      Returns a collection of keys for XBRL data sources.
      Returns:
        Set of strings

    - #### getSourceForKey

          XBRLDataSource getSourceForKey(java.lang.String key)

      Returns the XBRLDataSource for the key passed in as parameter.
      Parameters:
        `key` - the data source to obtain
      Returns:
        instance of a class implementing XBRLDataSource

    - #### getUriOfConfigFile

          java.net.URI getUriOfConfigFile()

      Access to the file name associated with the mapper configuration file.
      Returns:
        URI

    - #### getDtsURLs

          java.lang.String[] getDtsURLs()

      Access to all URLs that will be part of the DTS file section

      Note, all strings shall be valid converted to URIs to avoid errors.

      Returns:
        array of strings

    - #### getContainer

          DTSContainer getContainer()

      Access to the DTSContainer in the scope of the surrounding XMLFragments.
      Returns:
        DTSContainer instance

    - #### getSections

          java.util.Collection<Section> getSections()

      Access to the collection of sections.
      Returns:
        Collection of sections

    - #### getScheme

          java.lang.String getScheme()

      Access to the generic scheme string for the mapper configuration file

      Note, as this is a String, this may not be a valid URI.

      Returns:
        scheme URI as a string.

    - #### getCompany

          java.lang.String getCompany()

      Access to the generic string that corresponds with the company.
      Returns:
        String, company identifier

    - #### getUnitKeys

          java.util.Set<java.lang.String> getUnitKeys()

      Access to the set of keys for units defined in this mapping configuration file.
      Returns:
        Set of strings

    - #### getUnitForKey

          XBRLUnit getUnitForKey(java.lang.String key)

      Access to the unit associated with a specific key.
      Parameters:
        `key` - the key
      Returns:
        the unit for key

    - #### getChildrenFacts

          java.util.Iterator<Fact> getChildrenFacts()

      Access to facts on the configuration file.
      Returns:
        iterator on Fact instances